#!/usr/bin/env python

import roslib; roslib.load_manifest('mongodb')
import rospy
import subprocess
import sys
import os
from os import path
import shutil

if __name__ == '__main__':
    rospy.init_node('mongodb')
    dbpath = rospy.get_param('~database_path' , '/tmp/db')
    port = rospy.get_param('~port', 27017)
    overwrite = rospy.get_param('~overwrite', False)

    rospy.loginfo('Starting mongodb with db location {0}'.\
                  format(dbpath))

    if overwrite and path.exists(dbpath):
        shutil.rmtree(dbpath)
        rospy.loginfo('Removed existing db at %s', dbpath)

    if not path.exists(dbpath):
        rospy.loginfo('{0} did not exist; creating it.'.format(dbpath))
        os.makedirs(dbpath)

    try:
        retcode = subprocess.call("rosrun mongodb mongod --dbpath {0} --port {1}".\
                                  format(dbpath, port).split())
        if retcode < 0:
            rospy.logerr("Child was terminated by signal %s", -retcode)
        else:
            rospy.loginfo("Child returned")
    except OSError, e:
        rospy.logerr("Execution failed: %s", e)
  
