"""autogenerated by genmsg_py from Condition.msg. Do not edit."""
import roslib.message
import struct


class Condition(roslib.message.Message):
  _md5sum = "44691f2aeb7a218e22c96feb085564c8"
  _type = "warehouse/Condition"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# Represents an individual condition on a field in a query

# Field name, which can be nested.  E.g., "pose.position.x"
string field_name

# Predicate, which must be of one the types below
uint8 predicate

# Predicate arguments, which are parsed from strings, in a predicate-dependent manner
string[] args


## Predicate types

# numerical field must be less than args[0]
uint8 LESS_THAN=0

# numerical field must be greater than args[0]
uint8 GREATER_THAN=1

# field must equal args[0]
uint8 EQUALS=2
"""
  # Pseudo-constants
  LESS_THAN = 0
  GREATER_THAN = 1
  EQUALS = 2

  __slots__ = ['field_name','predicate','args']
  _slot_types = ['string','uint8','string[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       field_name,predicate,args
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(Condition, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.field_name is None:
        self.field_name = ''
      if self.predicate is None:
        self.predicate = 0
      if self.args is None:
        self.args = []
    else:
      self.field_name = ''
      self.predicate = 0
      self.args = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      _x = self.field_name
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      buff.write(_struct_B.pack(self.predicate))
      length = len(self.args)
      buff.write(_struct_I.pack(length))
      for val1 in self.args:
        length = len(val1)
        buff.write(struct.pack('<I%ss'%length, length, val1))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.field_name = str[start:end]
      start = end
      end += 1
      (self.predicate,) = _struct_B.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.args = []
      for i in xrange(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1 = str[start:end]
        self.args.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      _x = self.field_name
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      buff.write(_struct_B.pack(self.predicate))
      length = len(self.args)
      buff.write(_struct_I.pack(length))
      for val1 in self.args:
        length = len(val1)
        buff.write(struct.pack('<I%ss'%length, length, val1))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.field_name = str[start:end]
      start = end
      end += 1
      (self.predicate,) = _struct_B.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.args = []
      for i in xrange(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1 = str[start:end]
        self.args.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_B = struct.Struct("<B")
