"""autogenerated by genmsg_py from InitiateQueryRequest.msg. Do not edit."""
import roslib.message
import struct

import warehouse.msg

class InitiateQueryRequest(roslib.message.Message):
  _md5sum = "a16d57a61179cc1956c03193340744da"
  _type = "warehouse/InitiateQueryRequest"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """
string db_name
string collection_name


warehouse/Condition[] query

warehouse/OrderingCriterion order



bool metadata_only

================================================================================
MSG: warehouse/Condition
# Represents an individual condition on a field in a query

# Field name, which can be nested.  E.g., "pose.position.x"
string field_name

# Predicate, which must be of one the types below
uint8 predicate

# Predicate arguments, which are parsed from strings, in a predicate-dependent manner
string[] args


## Predicate types

# numerical field must be less than args[0]
uint8 LESS_THAN=0

# numerical field must be greater than args[0]
uint8 GREATER_THAN=1

# field must equal args[0]
uint8 EQUALS=2
================================================================================
MSG: warehouse/OrderingCriterion
# Represents an ordering criterion to use in a query result set

# Name of the (nested) field to order by, e.g., "position.x"
# Can also be "_creation_time"
string field

# If true, we'll use descending rather than ascending order
bool reverse
"""
  __slots__ = ['db_name','collection_name','query','order','metadata_only']
  _slot_types = ['string','string','warehouse/Condition[]','warehouse/OrderingCriterion','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       db_name,collection_name,query,order,metadata_only
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(InitiateQueryRequest, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.db_name is None:
        self.db_name = ''
      if self.collection_name is None:
        self.collection_name = ''
      if self.query is None:
        self.query = []
      if self.order is None:
        self.order = warehouse.msg.OrderingCriterion()
      if self.metadata_only is None:
        self.metadata_only = False
    else:
      self.db_name = ''
      self.collection_name = ''
      self.query = []
      self.order = warehouse.msg.OrderingCriterion()
      self.metadata_only = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      _x = self.db_name
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.collection_name
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.query)
      buff.write(_struct_I.pack(length))
      for val1 in self.query:
        _x = val1.field_name
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_B.pack(val1.predicate))
        length = len(val1.args)
        buff.write(_struct_I.pack(length))
        for val2 in val1.args:
          length = len(val2)
          buff.write(struct.pack('<I%ss'%length, length, val2))
      _x = self.order.field
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2B.pack(_x.order.reverse, _x.metadata_only))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      if self.order is None:
        self.order = warehouse.msg.OrderingCriterion()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.db_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.collection_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.query = []
      for i in xrange(0, length):
        val1 = warehouse.msg.Condition()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.field_name = str[start:end]
        start = end
        end += 1
        (val1.predicate,) = _struct_B.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.args = []
        for i in xrange(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val2 = str[start:end]
          val1.args.append(val2)
        self.query.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.order.field = str[start:end]
      _x = self
      start = end
      end += 2
      (_x.order.reverse, _x.metadata_only,) = _struct_2B.unpack(str[start:end])
      self.order.reverse = bool(self.order.reverse)
      self.metadata_only = bool(self.metadata_only)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      _x = self.db_name
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.collection_name
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.query)
      buff.write(_struct_I.pack(length))
      for val1 in self.query:
        _x = val1.field_name
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_B.pack(val1.predicate))
        length = len(val1.args)
        buff.write(_struct_I.pack(length))
        for val2 in val1.args:
          length = len(val2)
          buff.write(struct.pack('<I%ss'%length, length, val2))
      _x = self.order.field
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2B.pack(_x.order.reverse, _x.metadata_only))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      if self.order is None:
        self.order = warehouse.msg.OrderingCriterion()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.db_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.collection_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.query = []
      for i in xrange(0, length):
        val1 = warehouse.msg.Condition()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.field_name = str[start:end]
        start = end
        end += 1
        (val1.predicate,) = _struct_B.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.args = []
        for i in xrange(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val2 = str[start:end]
          val1.args.append(val2)
        self.query.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.order.field = str[start:end]
      _x = self
      start = end
      end += 2
      (_x.order.reverse, _x.metadata_only,) = _struct_2B.unpack(str[start:end])
      self.order.reverse = bool(self.order.reverse)
      self.metadata_only = bool(self.metadata_only)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_B = struct.Struct("<B")
_struct_2B = struct.Struct("<2B")
"""autogenerated by genmsg_py from InitiateQueryResponse.msg. Do not edit."""
import roslib.message
import struct


class InitiateQueryResponse(roslib.message.Message):
  _md5sum = "2445fbb91e099a39ade02d30b6062bd8"
  _type = "warehouse/InitiateQueryResponse"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """
string query_id




"""
  __slots__ = ['query_id']
  _slot_types = ['string']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       query_id
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(InitiateQueryResponse, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.query_id is None:
        self.query_id = ''
    else:
      self.query_id = ''

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      _x = self.query_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.query_id = str[start:end]
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      _x = self.query_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.query_id = str[start:end]
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
class InitiateQuery(roslib.message.ServiceDefinition):
  _type          = 'warehouse/InitiateQuery'
  _md5sum = '8bd9a1214f9512d68a0e5a3e2876a83b'
  _request_class  = InitiateQueryRequest
  _response_class = InitiateQueryResponse
