"""autogenerated by genmsg_py from RemoveMessagesRequest.msg. Do not edit."""
import roslib.message
import struct

import warehouse.msg

class RemoveMessagesRequest(roslib.message.Message):
  _md5sum = "7e4303fc6b23ec4988d0ff3fae7ae313"
  _type = "warehouse/RemoveMessagesRequest"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """

string db_name
string collection_name
warehouse/Condition[] conditions

================================================================================
MSG: warehouse/Condition
# Represents an individual condition on a field in a query

# Field name, which can be nested.  E.g., "pose.position.x"
string field_name

# Predicate, which must be of one the types below
uint8 predicate

# Predicate arguments, which are parsed from strings, in a predicate-dependent manner
string[] args


## Predicate types

# numerical field must be less than args[0]
uint8 LESS_THAN=0

# numerical field must be greater than args[0]
uint8 GREATER_THAN=1

# field must equal args[0]
uint8 EQUALS=2
"""
  __slots__ = ['db_name','collection_name','conditions']
  _slot_types = ['string','string','warehouse/Condition[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       db_name,collection_name,conditions
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(RemoveMessagesRequest, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.db_name is None:
        self.db_name = ''
      if self.collection_name is None:
        self.collection_name = ''
      if self.conditions is None:
        self.conditions = []
    else:
      self.db_name = ''
      self.collection_name = ''
      self.conditions = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      _x = self.db_name
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.collection_name
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.conditions)
      buff.write(_struct_I.pack(length))
      for val1 in self.conditions:
        _x = val1.field_name
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_B.pack(val1.predicate))
        length = len(val1.args)
        buff.write(_struct_I.pack(length))
        for val2 in val1.args:
          length = len(val2)
          buff.write(struct.pack('<I%ss'%length, length, val2))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.db_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.collection_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.conditions = []
      for i in xrange(0, length):
        val1 = warehouse.msg.Condition()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.field_name = str[start:end]
        start = end
        end += 1
        (val1.predicate,) = _struct_B.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.args = []
        for i in xrange(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val2 = str[start:end]
          val1.args.append(val2)
        self.conditions.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      _x = self.db_name
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.collection_name
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.conditions)
      buff.write(_struct_I.pack(length))
      for val1 in self.conditions:
        _x = val1.field_name
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_B.pack(val1.predicate))
        length = len(val1.args)
        buff.write(_struct_I.pack(length))
        for val2 in val1.args:
          length = len(val2)
          buff.write(struct.pack('<I%ss'%length, length, val2))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.db_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.collection_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.conditions = []
      for i in xrange(0, length):
        val1 = warehouse.msg.Condition()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.field_name = str[start:end]
        start = end
        end += 1
        (val1.predicate,) = _struct_B.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.args = []
        for i in xrange(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val2 = str[start:end]
          val1.args.append(val2)
        self.conditions.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_B = struct.Struct("<B")
"""autogenerated by genmsg_py from RemoveMessagesResponse.msg. Do not edit."""
import roslib.message
import struct


class RemoveMessagesResponse(roslib.message.Message):
  _md5sum = "788391563ab53b738044525b2669fcfb"
  _type = "warehouse/RemoveMessagesResponse"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """
uint32 num_messages_removed
uint8 error_code
string error_msg

uint8 SUCCESS=0
uint8 INVALID_DB_NAME=1
uint8 INVALID_COLLECTION_NAME=2




"""
  # Pseudo-constants
  SUCCESS = 0
  INVALID_DB_NAME = 1
  INVALID_COLLECTION_NAME = 2

  __slots__ = ['num_messages_removed','error_code','error_msg']
  _slot_types = ['uint32','uint8','string']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       num_messages_removed,error_code,error_msg
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(RemoveMessagesResponse, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.num_messages_removed is None:
        self.num_messages_removed = 0
      if self.error_code is None:
        self.error_code = 0
      if self.error_msg is None:
        self.error_msg = ''
    else:
      self.num_messages_removed = 0
      self.error_code = 0
      self.error_msg = ''

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      _x = self
      buff.write(_struct_IB.pack(_x.num_messages_removed, _x.error_code))
      _x = self.error_msg
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      end = 0
      _x = self
      start = end
      end += 5
      (_x.num_messages_removed, _x.error_code,) = _struct_IB.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.error_msg = str[start:end]
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      _x = self
      buff.write(_struct_IB.pack(_x.num_messages_removed, _x.error_code))
      _x = self.error_msg
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      end = 0
      _x = self
      start = end
      end += 5
      (_x.num_messages_removed, _x.error_code,) = _struct_IB.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.error_msg = str[start:end]
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_IB = struct.Struct("<IB")
class RemoveMessages(roslib.message.ServiceDefinition):
  _type          = 'warehouse/RemoveMessages'
  _md5sum = '16cc3633758e6558698695e643f5e022'
  _request_class  = RemoveMessagesRequest
  _response_class = RemoveMessagesResponse
